︠9c2c792c-0bf8-4f5f-bb7c-e5778704801ci︠
%html <h1>Some basic features of Python</h1>
︡87bf1a7f-e01f-4f1f-b3db-abc11bd276ab︡{"html":"<h1>Some basic features of Python</h1>"}︡{"done":true}︡
︠d4571679-a5eb-441c-bf7a-c1833b639534si︠
%html <h2>Looping over an iterable object</h2>
︡c2f081d5-5025-401d-bda0-2ee734419824︡{"html":"<h2>Looping over an iterable object</h2>"}︡{"done":true}︡
︠2a1df9d9-abc2-48d0-8072-f850d4f31444si︠
%md Suppose we want to count the number of subsets of $\{0,1,2,...,9\}$ that contain no adjacent elements.  First, we will define our universe and its power set.  The plan will be to define a function that determines whether a subset is "valid" in the sense that it contains no adjacent elements.  Then we will iterate over the subsets, counting the valid ones.

︡c57b9a8d-0dee-4807-98a7-7bb986fdb299︡{"md":"Suppose we want to count the number of subsets of $\\{0,1,2,...,9\\}$ that contain no adjacent elements.  First, we will define our universe and its power set.  The plan will be to define a function that determines whether a subset is \"valid\" in the sense that it contains no adjacent elements.  Then we will iterate over the subsets, counting the valid ones."}︡{"done":true}︡
︠89a59478-20cd-4e05-bf9a-a434e9f1b68f︠
U=Set(range(10))
power_set=U.subsets()
︡69cb83d6-2149-48cc-b9d9-08ce08d079e2︡{"done":true}︡
︠7e7c111c-ee03-43e4-85e9-fddc3da6494e︠
%md We know that the number of subsets will be 2 raised to the number of elements in $U$, which would be $2^{10}=1024$, but let's check.
︡4c1a7db7-2aed-4662-8bd1-c1f898ff2cd2︡{"md":"We know that the number of subsets will be 2 raised to the number of elements in $U$, which would be $2^{10}=1024$, but let's check.\n"}︡{"done":true}︡
︠9cb65551-9370-4152-ad00-f3ba9ea4adf6︠
len(power_set)
︡898c5e85-60d9-4479-8c2e-348a58e2a5d3︡{"stdout":"1024\n"}︡{"done":true}︡
︠86279e36-11c2-482e-912a-722540a576b9i︠
%md The validity check in this case is very simple.  For each element, $k$, of a set, $B$, we ask whether its successor, $k+1$, is also in the set.  If we never get an answer of "True" then we consider the set valid.  This function could be edited to define validity in other ways to answer different counting questions.
︡9edd0251-4b80-4497-871a-931ad5c86f04︡{"md":"The validity check in this case is very simple.  For each element, $k$, of a set, $B$, we ask whether its successor, $k+1$, is also in the set.  If we never get an answer of \"True\" then we consider the set valid.  This function could be edited to define validity in other ways to answer different counting questions."}︡{"done":true}︡
︠05ca7ecd-02db-48b4-ba6d-8fde3cacb9a4︠
def valid(B):
    v=true
    for k in B:
        if k+1 in B:
            v=false
            break
    return v


︡c44c6449-8887-4ff1-83c1-08ceef6efda7︡{"done":true}︡
︠f1d41e2d-5468-4157-8f89-67b28da9bf3fsi︠
%md  It's always a good idea to test your functions, so here is a list of two tests, one of a valid set and one of an invalid one.
︡25507539-ccaa-4e1a-a800-4a8c002470ad︡{"md":" It's always a good idea to test your functions, so here is a list of two tests, one of a valid set and one of an invalid one.\n"}︡{"done":true}︡
︠8408aaea-93e8-483e-b7ff-29548ee023bd︠
[valid(Set([1,3,5,9])),valid(Set([1,2,4,7,9]))]
︡173fc455-3519-43a0-9d9c-2281e78257de︡{"stdout":"[True, False]\n"}︡{"done":true}︡
︠a5ff7f46-086d-48f8-bcea-726c529e7b23i︠
%md Finally we do the counting over our power set, incrementing the count variable with each valid set.
︡4a81a209-4537-4b10-8e41-943cbb114f1c︡{"md":"Finally we do the counting over our power set, incrementing the count variable with each valid set."}︡{"done":true}︡
︠70941828-b209-4e32-b0f7-b9c2f3026196︠
count=0
for B in power_set:
    if valid(B):
        count+=1
count


︡e1fba588-884b-40e1-9443-2d1f617200cd︡{"stdout":"144\n"}︡{"done":true}︡
︠9020b069-4e4f-4005-8084-a8c81429c7e7︠

%html <h2>Dictionaries</h2>
︡5dee0af2-a794-4065-84d6-1d8d6e9d6ae4︡{"html":"<h2>Dictionaries</h2>"}︡{"done":true}︡
︠4ea0a37e-646f-4634-b071-3a66232f1817i︠
%html
<p>
Consider the following
</p>
︡9f69f566-c467-402f-80ef-ed9340642ddd︡{"done":true,"html":"<p>\nConsider the following     \n</p>"}
︠f5a4738b-430b-4704-b749-3f739b290bc5s︠
fruit_color={}
fruit_color['Red']=['apple','pomegranate','blood orange']
fruit_color['Yellow']=['banana','apple','lemon']
fruit_color['Green']=['apple','pear','grape','lime']
fruit_color['Purple']=['plum','grape']
fruit_color['Orange']=['orange','pineapple']
︡205c4b08-f8de-4eae-b8c8-3b9da0a65804︡{"done":true}︡
︠2f2cc859-72fe-4184-8404-9f6841a42282s︠

fruit_color
︡28e33660-2108-46a2-836f-80e1a95b9134︡{"stdout":"{'Purple': ['plum', 'grape'], 'Orange': ['orange', 'pineapple'], 'Green': ['apple', 'pear', 'grape', 'lime'], 'Yellow': ['banana', 'apple', 'lemon'], 'Red': ['apple', 'pomegranate', 'blood orange']}\n"}︡{"done":true}︡
︠31809636-c012-41ca-a281-b72f194555e3s︠
fruit_color.keys()
︡f6351e0f-cb8b-4e15-8c57-3dccd53072d1︡{"stdout":"['Purple', 'Orange', 'Green', 'Yellow', 'Red']\n"}︡{"done":true}︡
︠8f9c22d5-c1ec-44cd-a38e-60904784dcbfs︠
if 'Red' in fruit_color:
	fruit_color['Red']=fruit_color['Red']+['raspberry']
else:
	fruit_color['Red']=['raspberry']
fruit_color['Red']
︡82d716b3-02fa-4638-81db-b908cd2ec788︡{"stdout":"['apple', 'pomegranate', 'blood orange', 'raspberry']\n"}︡{"done":true}︡
︠ff4ea608-f705-45b2-b88b-333aa7e82752s︠
fruit_color.values()
︡27296c10-60d8-48d0-83bd-b85196b99e2c︡{"stdout":"[['plum', 'grape'], ['orange', 'pineapple'], ['apple', 'pear', 'grape', 'lime'], ['banana', 'apple', 'lemon'], ['apple', 'pomegranate', 'blood orange', 'raspberry']]\n"}︡{"done":true}︡
︠449be610-02a2-4475-85bb-bc3dcf1a3c29s︠
fruit_color.items()
︡616d1e1f-cc77-4fde-82d4-91beff659e89︡{"stdout":"[('Purple', ['plum', 'grape']), ('Orange', ['orange', 'pineapple']), ('Green', ['apple', 'pear', 'grape', 'lime']), ('Yellow', ['banana', 'apple', 'lemon']), ('Red', ['apple', 'pomegranate', 'blood orange', 'raspberry'])]\n"}︡{"done":true}︡
︠bb73a727-d2b1-40e4-9de9-a512220e10f6si︠
%md As an afterthough, we might add the information that a raspberry is red as follows. You have to be careful in that if 'Red' isn't already in the dictionary, it doesn't have a value. This is why we need an if statement.
︡bfd1a25f-92d4-4049-a179-7b8eb0b905ec︡{"md":"As an afterthough, we might add the information that a raspberry is red as follows. You have to be careful in that if 'Red' isn't already in the dictionary, it doesn't have a value. This is why we need an if statement."}︡{"done":true}︡
︠131cd5df-22c9-4025-b0b7-28e82a5cecc5s︠
if 'Red' in fruit_color:
	fruit_color['Red']=fruit_color['Red']+['raspberry']
else:
	fruit_color['Red']=['raspberry']
fruit_color['Red']

︡761f5093-c3d6-436b-98df-bdf76c5c259c︡{"stdout":"['apple', 'pomegranate', 'blood orange', 'raspberry', 'raspberry']\n"}︡{"done":true}︡
︠eb665edf-159c-48d7-a54c-164553a924fbs︠

︡67a39cb0-ba1f-48c6-9a53-e6fd8bf615cf︡{"done":true}︡
︠5bebfa28-253d-4353-9009-acfc5dcb1827s︠
for fruit in fruit_color:
    print [fruit,fruit_color[fruit]]
︡95b361cb-cabd-4109-9a99-aa8cc2941058︡{"stdout":"['Purple', ['plum', 'grape']]\n['Orange', ['orange', 'pineapple']]\n['Green', ['apple', 'pear', 'grape', 'lime']]\n['Yellow', ['banana', 'apple', 'lemon']]\n['Red', ['apple', 'pomegranate', 'blood orange', 'raspberry', 'raspberry']]\n"}︡{"done":true}︡
︠4ba7c2f6-53ed-47c1-9ecd-112f534a92c2s︠
DiGraph(fruit_color).plot()
︡f292c7c9-9e72-428f-88e3-efc202c06499︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/343/tmp_vJukrD.svg","show":true,"text":null,"uuid":"64b8e668-7761-4b47-b0cd-e31b08a4341d"},"once":false}︡{"done":true}︡
︠4cb99194-32aa-4d02-9269-cb8b2f6040d4s︠
color_pos={}
k=0
for c in fruit_color.keys():
    color_pos[c]=(-5,k)
    k+=1
color_pos
︡5fabc6cf-fe8e-416a-a204-efda06d9679d︡{"stdout":"{'Purple': (-5, 0), 'Orange': (-5, 1), 'Green': (-5, 2), 'Red': (-5, 4), 'Yellow': (-5, 3)}\n"}︡{"done":true}︡
︠7c16cf60-7f0b-44aa-bbde-5c15df374768s︠
fruits=Set([])
for v in fruit_color.values():
    fruits=fruits.union(Set(v))
k=0
for f in fruits:
    color_pos[f]=(5,k)
    k+=1
color_pos
︡4d0bfcbd-adb5-4e37-807f-549e1619819c︡{"stdout":"{'blood orange': (5, 0), 'grape': (5, 1), 'apple': (5, 2), 'Purple': (-5, 0), 'plum': (5, 10), 'pomegranate': (5, 3), 'pear': (5, 4), 'Yellow': (-5, 3), 'orange': (5, 7), 'Green': (-5, 2), 'pineapple': (5, 6), 'Orange': (-5, 1), 'lemon': (5, 8), 'raspberry': (5, 9), 'banana': (5, 5), 'Red': (-5, 4), 'lime': (5, 11)}\n"}︡{"done":true}︡
︠a12ffcd3-a1ba-4936-929b-589a3a96a31es︠

︡85458a7d-b0d4-4d76-98b9-de839300c49a︡{"done":true}︡
︠971b3ccc-d90a-4f3d-9e00-7f536bb96dd4s︠
DiGraph(fruit_color).plot(pos=color_pos,vertex_size=1,edge_style='dashed')
︡84613ba5-7e3b-4d4b-987b-48d2ba76a894︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/343/tmp_UF5oXC.svg","show":true,"text":null,"uuid":"6eaea150-d497-411f-9128-6fdd852b9132"},"once":false}︡{"done":true}︡
︠f660bd13-8b54-43f8-9247-e26f1a57181as︠
from sage.plot.colors import rainbow
R=rainbow(5)
mlibcolor={}
mlibcolor['R(0)']='Red'
mlibcolor['R(1)']='Green'
mlibcolor['R(2)']='Yellow'
mlibcolor['R(3)']='Orange'
mlibcolor['R(4)']='Purple'
︡cc819965-4964-4c8f-84cb-3f5cc15bf88b︡{"done":true}︡
︠97e772a1-3627-47b6-8321-6596a15984e2︠

︡40e17b62-06b0-4d45-9379-2e182a4ef04a︡
︠67513ba6-d0b8-46f0-bec2-3d909d21ea3as︠

︡56879bba-3f3f-465b-9b2e-2cdd8ecbe32d︡{"done":true}︡
︠157679ca-05b5-4ccc-bb7e-303740a52788s︠
fr=DiGraph(fruit_color)
eds=fr.edges()
e_colors={}
for hue in mlibcolor:
    e_colors[hue]=filter(lambda ed:ed[0]==mlibcolor[hue],eds)
e_colors
︡b96948b7-c35d-477a-955a-11eab428be70︡{"stdout":"{'R(0)': [('Red', 'apple', None), ('Red', 'blood orange', None), ('Red', 'pomegranate', None), ('Red', 'raspberry', None), ('Red', 'raspberry', None)], 'R(1)': [('Green', 'apple', None), ('Green', 'grape', None), ('Green', 'lime', None), ('Green', 'pear', None)], 'R(2)': [('Yellow', 'apple', None), ('Yellow', 'banana', None), ('Yellow', 'lemon', None)], 'R(3)': [('Orange', 'orange', None), ('Orange', 'pineapple', None)], 'R(4)': [('Purple', 'grape', None), ('Purple', 'plum', None)]}\n"}︡{"done":true}︡
︠1e25d3be-dd18-4e9d-8b09-020775535fe6s︠
DiGraph(fruit_color).plot(pos=color_pos,vertex_size=1,edge_colors=e_colors)
︡bd1e070c-c3c1-41da-911d-97aa6096d3c3︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1013, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\", line 3594, in displayhook\n    show(obj)\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\", line 2678, in show\n    s = show0(objs, combine_all=True)\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\", line 2639, in show0\n    b = show0(a)\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\", line 2606, in show0\n    show_2d_plot_using_matplotlib(obj, svg=svg, **kwds)\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_salvus.py\", line 2434, in show_2d_plot_using_matplotlib\n    obj.save(t, **kwds)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/misc/decorators.py\", line 483, in wrapper\n    return func(*args, **kwds)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/plot/graphics.py\", line 3147, in save\n    figure = self.matplotlib(**options)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/plot/graphics.py\", line 2598, in matplotlib\n    g._render_on_subplot(subplot)\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/plot/arrow.py\", line 144, in _render_on_subplot\n    color = to_mpl_color(options['rgbcolor'])\n  File \"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/plot/colors.py\", line 349, in rgbcolor\n    raise ValueError(\"unknown color '%s'\" % c)\nValueError: unknown color 'R(0)'\n"}︡{"done":true}︡
︠39826717-abb0-42f2-8d83-e5965fc81a55s︠
DiGraph(fruit_color).plot?
︡aea9fbaa-0be1-4ab4-82cf-1b0ebd56554e︡{"code":{"filename":null,"lineno":-1,"mode":"text/x-rst","source":"File: /ext/sage/sage-8.1/local/lib/python2.7/site-packages/sage/misc/decorators.py\nSignature : DiGraph(fruit_color).plot(self, **kwds)\nDocstring :\nReturns a graphics object representing the (di)graph.\n\nINPUT:\n\n* \"pos\" - an optional positioning dictionary\n\n* \"layout\" - what kind of layout to use, takes precedence over\n  pos\n\n     * 'circular' -- plots the graph with vertices evenly\n       distributed on a circle\n\n     * 'spring' - uses the traditional spring layout, using the\n       graph's current positions as initial positions\n\n     * 'tree' - the (di)graph must be a tree. One can specify the\n       root of the tree using the keyword tree_root, otherwise a\n       root will be selected at random. Then the tree will be\n       plotted in levels, depending on minimum distance for the\n       root.\n\n* \"vertex_labels\" - whether to print vertex labels\n\n* \"edge_labels\" - whether to print edge labels. By default,\n  False, but if True, the result of str(l) is printed on the edge\n  for each label l. Labels equal to None are not printed (to set\n  edge labels, see set_edge_label).\n\n* \"edge_labels_background\" - The color of the edge labels\n  background. The default is \"white\". To achieve a transparent\n  background use \"transparent\".\n\n* \"vertex_size\" - size of vertices displayed\n\n* \"vertex_shape\" - the shape to draw the vertices, for example\n  \"\"o\"\" for circle or \"\"s\"\" for square. Whole list is available at\n  http://matplotlib.org/api/markers_api.html. (Not available for\n  multiedge digraphs.)\n\n* \"graph_border\" - whether to include a box around the graph\n\n* \"vertex_colors\" - optional dictionary to specify vertex colors:\n  each key is a color recognizable by matplotlib, and each\n  corresponding entry is a list of vertices. If a vertex is not\n  listed, it looks invisible on the resulting plot (it doesn't get\n  drawn).\n\n* \"edge_colors\" - a dictionary specifying edge colors: each key\n  is a color recognized by matplotlib, and each entry is a list of\n  edges.\n\n* \"partition\" - a partition of the vertex set. if specified, plot\n  will show each cell in a different color. vertex_colors takes\n  precedence.\n\n* \"talk\" - if true, prints large vertices with white backgrounds\n  so that labels are legible on slides\n\n* \"iterations\" - how many iterations of the spring layout\n  algorithm to go through, if applicable\n\n* \"color_by_label\" - a boolean or dictionary or function\n  (default: False) whether to color each edge with a different\n  color according to its label; the colors are chosen along a\n  rainbow, unless they are specified by a function or dictionary\n  mapping labels to colors; this option is incompatible with\n  \"edge_color\" and \"edge_colors\".\n\n* \"heights\" - if specified, this is a dictionary from a set of\n  floating point heights to a set of vertices\n\n* \"edge_style\" - keyword arguments passed into the edge-drawing\n  routine.  This currently only works for directed graphs, since we\n  pass off the undirected graph to networkx\n\n* \"tree_root\" - a vertex of the tree to be used as the root for\n  the layout=\"tree\" option. If no root is specified, then one is\n  chosen at random. Ignored unless layout='tree'.\n\n* \"tree_orientation\" - \"up\" or \"down\" (default is \"down\"). If\n  \"up\" (resp., \"down\"), then the root of the tree will appear on\n  the bottom (resp., top) and the tree will grow upwards (resp.\n  downwards). Ignored unless layout='tree'.\n\n* \"save_pos\" - save position computed during plotting\n\nNote:\n\n  * This method supports any parameter accepted by\n    \"sage.plot.graphics.Graphics.show()\".\n\n  * See the documentation of the \"sage.graphs.graph_plot\" module\n    for information and examples of how to define parameters that\n    will be applied to **all** graph plots.\n\n  * Default parameters for this method *and a specific graph* can\n    also be set through the \"options\" mechanism. For more\n    information on this different way to set default parameters,\n    see the help of the \"options decorator\".\n\n  * See also the \"sage.graphs.graph_latex\" module for ways to use\n    LaTeX to produce an image of a graph.\n\nEXAMPLES:\n\n   sage: from sage.graphs.graph_plot import graphplot_options\n   sage: list(sorted(graphplot_options.items()))\n   [...]\n\n   sage: from math import sin, cos, pi\n   sage: P = graphs.PetersenGraph()\n   sage: d = {'#FF0000':[0,5], '#FF9900':[1,6], '#FFFF00':[2,7], '#00FF00':[3,8], '#0000FF':[4,9]}\n   sage: pos_dict = {}\n   sage: for i in range(5):\n   ....:  x = float(cos(pi/2 + ((2*pi)/5)*i))\n   ....:  y = float(sin(pi/2 + ((2*pi)/5)*i))\n   ....:  pos_dict[i] = [x,y]\n   ...\n   sage: for i in range(5, 10):\n   ....:  x = float(0.5*cos(pi/2 + ((2*pi)/5)*i))\n   ....:  y = float(0.5*sin(pi/2 + ((2*pi)/5)*i))\n   ....:  pos_dict[i] = [x,y]\n   ...\n   sage: pl = P.plot(pos=pos_dict, vertex_colors=d)\n   sage: pl.show()\n\n   sage: C = graphs.CubeGraph(8)\n   sage: P = C.plot(vertex_labels=False, vertex_size=0, graph_border=True)\n   sage: P.show()\n\n   sage: G = graphs.HeawoodGraph()\n   sage: for u,v,l in G.edges():\n   ....:     G.set_edge_label(u,v,'(' + str(u) + ',' + str(v) + ')')\n   sage: G.plot(edge_labels=True).show()\n\n   sage: D = DiGraph( { 0: [1, 10, 19], 1: [8, 2], 2: [3, 6], 3: [19, 4], 4: [17, 5], 5: [6, 15], 6: [7], 7: [8, 14], 8: [9], 9: [10, 13], 10: [11], 11: [12, 18], 12: [16, 13], 13: [14], 14: [15], 15: [16], 16: [17], 17: [18], 18: [19], 19: []} , sparse=True)\n   sage: for u,v,l in D.edges():\n   ....:     D.set_edge_label(u,v,'(' + str(u) + ',' + str(v) + ')')\n   sage: D.plot(edge_labels=True, layout='circular').show()\n\n   sage: from sage.plot.colors import rainbow\n   sage: C = graphs.CubeGraph(5)\n   sage: R = rainbow(5)\n   sage: edge_colors = {}\n   sage: for i in range(5):\n   ....:  edge_colors[R[i]] = []\n   sage: for u,v,l in C.edges():\n   ....:  for i in range(5):\n   ....:      if u[i] != v[i]:\n   ....:          edge_colors[R[i]].append((u,v,l))\n   sage: C.plot(vertex_labels=False, vertex_size=0, edge_colors=edge_colors).show()\n\n   sage: D = graphs.DodecahedralGraph()\n   sage: Pi = [[6,5,15,14,7],[16,13,8,2,4],[12,17,9,3,1],[0,19,18,10,11]]\n   sage: D.show(partition=Pi)\n\n   sage: G = graphs.PetersenGraph()\n   sage: G.allow_loops(True)\n   sage: G.add_edge(0,0)\n   sage: G.show()\n\n   sage: D = DiGraph({0:[0,1], 1:[2], 2:[3]}, loops=True)\n   sage: D.show()\n   sage: D.show(edge_colors={(0,1,0):[(0,1,None),(1,2,None)],(0,0,0):[(2,3,None)]})\n\n   sage: pos = {0:[0.0, 1.5], 1:[-0.8, 0.3], 2:[-0.6, -0.8], 3:[0.6, -0.8], 4:[0.8, 0.3]}\n   sage: g = Graph({0:[1], 1:[2], 2:[3], 3:[4], 4:[0]})\n   sage: g.plot(pos=pos, layout='spring', iterations=0)\n   Graphics object consisting of 11 graphics primitives\n\n   sage: G = Graph()\n   sage: P = G.plot()\n   sage: P.axes()\n   False\n   sage: G = DiGraph()\n   sage: P = G.plot()\n   sage: P.axes()\n   False\n\n   sage: G = graphs.PetersenGraph()\n   sage: G.get_pos()\n   {0: (6.12..., 1.0...),\n    1: (-0.95..., 0.30...),\n    2: (-0.58..., -0.80...),\n    3: (0.58..., -0.80...),\n    4: (0.95..., 0.30...),\n    5: (1.53..., 0.5...),\n    6: (-0.47..., 0.15...),\n    7: (-0.29..., -0.40...),\n    8: (0.29..., -0.40...),\n    9: (0.47..., 0.15...)}\n   sage: P = G.plot(save_pos=True, layout='spring')\n\n   The following illustrates the format of a position dictionary.\n\n   sage: G.get_pos() # currently random across platforms, see #9593\n   {0: [1.17..., -0.855...],\n    1: [1.81..., -0.0990...],\n    2: [1.35..., 0.184...],\n    3: [1.51..., 0.644...],\n    4: [2.00..., -0.507...],\n    5: [0.597..., -0.236...],\n    6: [2.04..., 0.687...],\n    7: [1.46..., -0.473...],\n    8: [0.902..., 0.773...],\n    9: [2.48..., -0.119...]}\n\n   sage: T = list(graphs.trees(7))\n   sage: t = T[3]\n   sage: t.plot(heights={0:[0], 1:[4,5,1], 2:[2], 3:[3,6]})\n   Graphics object consisting of 14 graphics primitives\n\n   sage: T = list(graphs.trees(7))\n   sage: t = T[3]\n   sage: t.plot(heights={0:[0], 1:[4,5,1], 2:[2], 3:[3,6]})\n   Graphics object consisting of 14 graphics primitives\n   sage: t.set_edge_label(0,1,-7)\n   sage: t.set_edge_label(0,5,3)\n   sage: t.set_edge_label(0,5,99)\n   sage: t.set_edge_label(1,2,1000)\n   sage: t.set_edge_label(3,2,'spam')\n   sage: t.set_edge_label(2,6,3/2)\n   sage: t.set_edge_label(0,4,66)\n   sage: t.plot(heights={0:[0], 1:[4,5,1], 2:[2], 3:[3,6]}, edge_labels=True)\n   Graphics object consisting of 20 graphics primitives\n\n   sage: T = list(graphs.trees(7))\n   sage: t = T[3]\n   sage: t.plot(layout='tree')\n   Graphics object consisting of 14 graphics primitives\n\n   sage: t = DiGraph('JCC???@A??GO??CO??GO??')\n   sage: t.plot(layout='tree', tree_root=0, tree_orientation=\"up\")\n   Graphics object consisting of 22 graphics primitives\n   sage: D = DiGraph({0:[1,2,3], 2:[1,4], 3:[0]})\n   sage: D.plot()\n   Graphics object consisting of 16 graphics primitives\n\n   sage: D = DiGraph(multiedges=True,sparse=True)\n   sage: for i in range(5):\n   ....:   D.add_edge((i,i+1,'a'))\n   ....:   D.add_edge((i,i-1,'b'))\n   sage: D.plot(edge_labels=True,edge_colors=D._color_by_label())\n   Graphics object consisting of 34 graphics primitives\n   sage: D.plot(edge_labels=True, color_by_label={'a':'blue', 'b':'red'}, edge_style='dashed')\n   Graphics object consisting of 34 graphics primitives\n\n   sage: g = Graph({}, loops=True, multiedges=True,sparse=True)\n   sage: g.add_edges([(0,0,'a'),(0,0,'b'),(0,1,'c'),(0,1,'d'),\n   ....:   (0,1,'e'),(0,1,'f'),(0,1,'f'),(2,1,'g'),(2,2,'h')])\n   sage: g.plot(edge_labels=True, color_by_label=True, edge_style='dashed')\n   Graphics object consisting of 26 graphics primitives\n\n   sage: S = SupersingularModule(389)\n   sage: H = S.hecke_matrix(2)\n   sage: D = DiGraph(H,sparse=True)\n   sage: P = D.plot()\n\n   sage: G=Graph({'a':['a','b','b','b','e'],'b':['c','d','e'],'c':['c','d','d','d'],'d':['e']},sparse=True)\n   sage: G.show(pos={'a':[0,1],'b':[1,1],'c':[2,0],'d':[1,0],'e':[0,0]})"}}︡{"done":true}︡
︠e6795d7f-96f4-4761-a078-71d9eb7e83cbr︠
%html <h2>
    Truth Tables
</h2>
︡7832fc7e-4e02-4a7b-b1de-c4d62cd39372︡
︠c4d4a9cf-307b-4816-90fb-06033f895fbf︠

bool=['False','True']
︡070789bb-9068-4760-a777-453ff70c85a1︡
︠d6e4800d-b17e-452a-b7bd-80eba4704fd9w︠
cases=tuples(bool,2)
︡9245bb6d-e01a-430c-b053-a454742e3e58︡
︠4229ef70-f1c9-4c99-a37b-06861e7d03e8︠









